stages:
  - build
  - prep_qa
  - deploy_qa
  - deploy_prod

# Build image on oci-instance-2
build_app_container:
  when: manual
  tags:
    - docker
  stage: build
  script:
    - docker build -t guillaumegoutaudier/cloud-native:app-build-$CI_COMMIT_SHORT_SHA ./app
    - docker login -u guillaumegoutaudier -p uve6ahN2aeG1pah0
    - docker push guillaumegoutaudier/cloud-native:app-build-$CI_COMMIT_SHORT_SHA
  artifacts:
    paths:
      - app/

# QA environment: micro-K8s on oci-instance-2 
clean_up_qa:
  when: manual
  tags:
    - microk8s
  stage: prep_qa
  script: 
    - ./scripts/kill_k8s_app.sh
    - ./scripts/kill_k8s_db.sh
deploy_qa:
  when: manual
  tags:
    - microk8s
  stage: deploy_qa
  script: 
    - kubectl create -f k8s/db.yml 
    - ./k8s/test_db_k8s.sh
    - export MYSQL_ROOT_PASSWORD=secret
    - export DB_SERVICE_SERVICE_HOST=`python3 k8s/get_service_ip.py`
    - export DB_SERVICE_SERVICE_PORT=3306
    - export MYSQL_MESSAGE='Hello World from QA'
    - python3 app/init_db.py
    - cat k8s/app_deployment_template.yml | sed -e "s/XXX/$CI_COMMIT_SHORT_SHA/" > k8s/app_deployment.yml
    - kubectl create -f k8s/app_deployment.yml 
    - kubectl create -f k8s/app_service.yml 
    - ./scripts/wait_for_app.sh
    - python3 k8s/test_app_k8s.py
    - python3 k8s/test_app_db_k8s.py

# Prod environment: OKE with kubectl on oci-instance-1
deploy_prod:
  when: manual
  tags:
    - oke
  stage: deploy_prod
  script:
    - kubectl set image deployment app-deployment app-container=guillaumegoutaudier/cloud-native:app-build-$CI_COMMIT_SHORT_SHA  --record
    - kubectl rollout status deployment.v1.apps/app-deployment
    - python3 oke/test_app_oke.py
    - python3 oke/test_app_db_oke.py




